# coding: utf-8

require 'rb_conclas/core/exceptions/api_custom_exceptions'
require 'json'


module Conclas
  module Core
    class ConclasResponse
      def initialize(result, status_code, headers)
        @result = JSON.parse(result, :quirks_mode => true)
        @status_code = status_code
        @headers = headers
      end

      def raise_exception(code)
        if code == 10
          raise Exceptions::InvalidTokenException, "Missing token."
        elsif code == 11
          raise Exceptions::InvalidTokenException, "Token format is invalid."
        elsif code == 12
          raise Exceptions::InvalidTokenException, "Credentials are not correct."
        elsif code == 13
          raise Exceptions::InvalidModeException, "Invalid mode request."
        elsif code == 14
          raise Exceptions::InvalidBodyException, "Invalid Body Message."
        elsif code == 15
          raise Exceptions::InvalidBodyException, "Invalid Body Json format."
        else
          raise "Error not categorized"
        end
      end

      private :raise_exception

      def request_successful?
        if @result.key?("errors")
          code = @result["errors"][0]["code"].to_i
          raise_exception(code)
        end
        true
      end
    end
  end
end