# coding: utf-8

require 'net/http'
require 'uri'
require 'json'

module Conclas
  module Core
  # class to make requester to server
    module Requester
      def self.post(url, data, headers, timeout, use_ssl)
        begin
          uri = URI.parse(url) # parse url data(port and host)

          http = Net::HTTP.new(uri.host, uri.port) #create http object with uri data
          http.use_ssl = use_ssl
          http.read_timeout = timeout
          request = Net::HTTP::Post.new(uri.request_uri, initheader = headers)
          request.body = data
          http.request(request)
        rescue Timeout::Error, Errno::EINVAL, Errno::ECONNRESET, EOFError,
              Net::HTTPBadResponse, Net::ReadTimeout, Net::HTTPHeaderSyntaxError, Net::ProtocolError => e
          raise e
        end
      end
    end
  end
end
